!-----------------------
! madgraph - a Feynman Diagram package by Tim Stelzer and Bill Long 
! (c) 1993
!
! Filename: writesub.f
!-----------------------
 
      subroutine writeamp(ngraphs,nexternal,nqed,nqcd,nproc,ncolor)
!***************************************************************************
!     writes out the subroutines
!***************************************************************************
      implicit none

! Constants

      include 'params.inc'
      integer    ln   
      parameter (ln=92 )

! Arguments

      integer ngraphs,nqed,nqcd,nexternal,nproc,ncolor


! Local Variables

      character*75 buff
      character*20 name
c      character*4 temp
      integer i,jchar,ishift,nlength,j,k,ic,nflows
      integer idenom,inum

! External
      
      logical equal
      integer igcf

! Global Variables
      double precision               den(maxgraphs)
      integer           neigen,nrows,jplace(maxgraphs)
      common /to_colormat/ den,neigen,nrows,jplace

      integer flows(0:2*maxlines,0:maxfactors,0:24,0:maxflows)
      integer         graphcolor(0:2,0:maxflows,0:maxgraphs)
      common/to_color/graphcolor,flows

      integer alen(maxgraphs)
      integer wnum(-maxlines:maxlines),wcount,wlen(maxgraphs*maxlines)
      common/toopt/wcount,wnum,wlen,alen

      character*15 gname
      integer iname
      common/to_name/iname,gname
      character*60 proc
      integer iproc
      common/to_write/iproc,proc
      integer            symfact(maxgraphs)
      common /tosymmetry/symfact

!-----------
! Begin Code
!-----------


      ishift = iname
      nlength = ishift
      if (nproc .gt. 0) then
         open(unit=ln,file=gname(1:iname)//'.f',status='unknown')
         write(isubfile,'($a)') gname(1:iname),'.o '
      else
         open(unit=ln,status='scratch')
      endif
      name = gname(1:iname)
      call upper_case(name)

      print*,'Writing function ',name(1:iname) ,
     &     ' in file ',GNAME(1:iname)//'.f.'

      call writesum(nproc)

      buff = 'REAL*8 FUNCTION '
      jchar = 17
      buff(jchar:jchar+ishift) = name(1:iname)
      jchar = jchar+ishift
      ishift= 10
      buff(jchar:jchar+ishift) = '(P,NHEL,IC)'
      jchar =jchar+ishift
      ishift = 4
      write(ln,'(6x,a)') buff(1:jchar)

! write comments

      write(ln,5) ' '
      write(ln,5) 'FUNCTION GENERATED BY MADGRAPH'
      write(ln,5) 'RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS'
      write(ln,5) 'FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)'
c      write(ln,5) 'FOR THE POINT IN PHASE SPACE P(0:3,N_PARTICLES)'
      write(ln,5) ' '
      write(ln,5) 'FOR PROCESS '//proc(1:iproc)
      write(ln,5) ' '

      write(ln,10) 'IMPLICIT NONE'

! write parameters

      write(ln,5) ' '
      write(ln,5) 'CONSTANTS'
      write(ln,5) ' '

      buff = 'INTEGER    NGRAPHS,    NEIGEN,    NEXTERNAL'
      write(ln,10) buff(1:50)
      buff = 'PARAMETER (NGRAPHS=????,NEIGEN=???,NEXTERNAL=?)'
      write(buff(20:23),'(i4)') ngraphs
      write(buff(32:34),'(i3)') neigen
      write(buff(46:46),'(i1)') nexternal
      write(ln,10) buff(1:50)
      buff = 'INTEGER    NWAVEFUNCS     , NCOLOR'
      write(ln,10) buff(1:34)
      buff = 'PARAMETER (NWAVEFUNCS=????, NCOLOR=????) '
      write(buff(23:26),'(i4)') WCOUNT
      write(buff(36:39),'(i4)') NCOLOR
c      write(buff(36:39),'(i4)') NROWS
      write(ln,10) buff(1:41)
      write(ln,10) 'REAL*8     ZERO'
      write(ln,10) 'PARAMETER (ZERO=0D0)'

! write argument declarations

      write(ln,5) ' '
      write(ln,5) 'ARGUMENTS '
      write(ln,5) ' '

      write(ln,10) 'REAL*8 P(0:3,NEXTERNAL)'
      write(ln,10) 'INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)'


! write local declarations

      write(ln,5) ' '
      write(ln,5) 'LOCAL VARIABLES '
      write(ln,5) ' '

      write(ln,10) 'INTEGER I,J'
      write(ln,10) 'COMPLEX*16 ZTEMP'
      write(ln,10) 'REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)'
      write(ln,10) 'COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)'
      write(ln,10) 'COMPLEX*16 W(6,NWAVEFUNCS)'
c      write(ln,10) 'REAL*8 RMAX,IMAX'


! write global declarations

      write(ln,5) ' '
      write(ln,5) 'GLOBAL VARIABLES'
      write(ln,5) ' '

      write(ln,10) 'INCLUDE \'coupl.inc\''
      write(ln,10) 'INCLUDE \'coupmssm.inc\''

      write(ln,5) ' '
      write(ln,5) 'COLOR DATA'
      write(ln,5) ' '

      do while (.true.)
         read(99,'(a)',end=99) buff
         write(ln,'(a)') buff
      enddo
 99   continue

      write(ln,5) '----------'
      write(ln,5) 'BEGIN CODE'
      write(ln,5) '----------'
      
      do while (.true.)
         read(91,'(a)',end=999) buff
         write(ln,'(a)') buff
      enddo
 999  continue

      nflows=flows(0,0,0,0)

c      write(*,*) 'Writing flows',nflows
      do i=1,nflows
c
c     First determine a common denominator for these amplitudes
c
         idenom=1
         inum = 999999
         do j=1,ngraphs
            do k=1,graphcolor(0,0,j)         !Number of terms/flows
               if (graphcolor(0,k,j) .eq. i) then
                  inum = min(inum,abs(graphcolor(1,k,j)))
c                  write(*,*) i,j,k,idenom,graphcolor(2,k,j)
                  idenom=abs(idenom*graphcolor(2,k,j)/
     &                 igcf(idenom,graphcolor(2,k,j)))
c                  write(*,*) i,j,k,idenom,graphcolor(2,k,j)
               endif
            enddo
         enddo
         if (idenom .ne. 1) inum=1
         if (inum .eq. 1 .and. idenom .eq. 1) then
            write(ln,'($a,i4,a)')    '      JAMP(',i,') = '
            ic = 19
         elseif (inum .ne. 1) then
            write(ln,'($a,i4,a,i6,a)')    '      JAMP(',i,') = ',
     &           inum,'*( '
            ic = 28 
         elseif (idenom .ne. 1) then
            write(ln,'($a,i4,a)')    '      JAMP(',i,') = (',
     &           '('
            ic = 20 
         endif
         do j=1,ngraphs
            do k=1,graphcolor(0,0,j)         !Number of terms/flows
            if (graphcolor(0,k,j) .eq. i) then                 
               if (ic .gt. 60) then                    
                  write(ln,*)                          
                  write(ln,'($a)')'     &             '
                  ic = 19
               endif
               den(j)=1d0
               den(j)=dble(graphcolor(1,k,j))/graphcolor(2,k,j)*
     &              idenom*symfact(j)/inum
c               write(*,*) i,j,k,idenom,graphcolor(1,k,j),
c     &              graphcolor(2,k,j),den(j)
c               if (equal(den(j)/den(i),1d0)) then
               if (equal(den(j),1d0)) then
                  write(ln,'($a,i4,a)') '+AMP(',j,')'
                  ic = ic+10
c               elseif (equal(den(j)/den(i),-1d0)) then
               elseif (equal(den(j),-1d0)) then
                  ic = ic+10
                  write(ln,'($a,i4,a)') '-AMP(',j,')'
c               elseif (den(j)/den(i) .gt. 0d0) then
               elseif (den(j) .gt. 0d0) then
                  if (ic .gt. 50) then
                     write(ln,*)
                     write(ln,'($a)')'     & '
                     ic = 8
                  endif
                  ic = ic+22
                  write(ln,'($a,e10.3,a,i4,a)') '+'
     $                ,den(j),'*AMP(',j,')'
c               elseif (den(j)/den(i) .lt. 0d0) then
               elseif (den(j) .lt. 0d0) then
                  if (ic .gt. 50) then
                     write(ln,*)
                     write(ln,'($a)')'     & '
                     ic = 8
                  endif
                  ic = ic+22
                  write(ln,'($a,e10.3,a,i4,a)') '-'
     $                ,abs(den(j)),'*AMP(',j,')'
c     $                 ,den(j)/den(i),'*AMP(',j,')'
               endif
            endif
         enddo
         enddo
         if (idenom .ne. 1) then
            write(ln,'($a,i6)') ')/',idenom 
         elseif (inum .ne. 1) then
            write(ln,'($a)') ')'
         endif
         write(ln,*)
      enddo
c      write(ln,10) 'RMAX = 1D-53'
c      write(ln,10) 'IMAX = 1D-53'
      buff(1:nlength) = name(1:nlength)
      buff(nlength+1:nlength+8) = ' = 0.D0'
      write(ln,10) buff(1:nlength+8)
      write(ln,10) 'DO I = 1, NCOLOR'
      write(ln,10) '    ZTEMP = (0.D0,0.D0)'
      write(ln,10) '    DO J = 1, NCOLOR'
      write(ln,10) '        ZTEMP = ZTEMP + CF(J,I)*JAMP(J)'
c      write(ln,10) '        RMAX  = MAX(RMAX,ABS( DBLE(ZTEMP)))'
c      write(ln,10) '        IMAX  = MAX(IMAX,ABS(DIMAG(ZTEMP)))'
      write(ln,10) '    ENDDO'
      buff(1:4) = '    '
      buff(5:nlength+5) = name(1:nlength)
      buff(nlength+6:nlength+6) = '='
      buff(nlength+7:2*nlength+7) = name(1:nlength)
      buff(2*nlength+7:2*nlength+40)='+ZTEMP*DCONJG(JAMP(I))/DENOM(I)'
      write(ln,10) buff(1:2*nlength+40)

      buff= '    ZERROR = DCMPLX(ABS(ZTEMP)/RMAX,ABS(ZTEMP)/IMAX)'
c      write(ln,10) buff(1:52)
c      write(ln,10) '    IF (DBLE(ZERROR) .LT. -1D-9) THEN'
      buff(1:15) = '        PRINT*,'
      buff(16:16) = char(39)
      buff(17:47) ='WARNING LARGE CANCELLATIONS IN '
      buff(48:48+nlength) = name(1:nlength)//char(39)
c      write(ln,10) buff(1:48+nlength)
      buff(1:15) = '        PRINT*,'
      buff(16:16) = char(39)
      buff(17:37) ='Number of digits lost '
      buff(38:38) = char(39)
      buff(39:64) = ',INT(-LOG10(DBLE(ZERROR)))'
c      write(ln,10) buff(1:64)
c      write(ln,10) '    ENDIF'

c      write(ln,10) '    IF (DIMAG(ZERROR) .LT. -1D-9) THEN'
      buff(1:15) = '       PRINT*,'
      buff(16:16) = char(39)
      buff(17:47) ='WARNING LARGE CANCELLATIONS IN '
      buff(48:48+nlength) = name(1:nlength)//char(39)
c      write(ln,10) buff(1:48+nlength)
      buff(1:14) = '       PRINT*,'
      buff(15:15) = char(39)
      buff(16:36) ='Number of digits lost '
      buff(37:37) = char(39)
      buff(38:64) = ',INT(-LOG10(DIMAG(ZERROR)))'
c      write(ln,10) buff(1:64)
c      write(ln,10) '    ENDIF'
      

      write(ln,10) 'ENDDO'
      buff(1:47)='CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,'
      buff(48:62)='NCOLOR,NEIGEN)'
      write(ln,15) buff(1:62)
      write(ln,10) 'END'

      close(ln)

 5    format('C ',A)
 10   format(6X,A)
 15   format('C',6X,A)
 20   format(', P',I1)
 30   format(',P',I1,'(0:3)')
      end

 
      subroutine writesum(nproc)
!***************************************************************************
!     writes out the subroutine which sums over helicities and
!     and does all crossings
!***************************************************************************
      implicit none

! Constants

      include 'params.inc'
c      integer    maxlines  , maxcross
c      parameter (maxlines=8, maxcross=200)
c      integer    max_coup
c      parameter (max_coup=5)
c      integer    max_particles       
c      parameter (max_particles=2**7-1)
c      integer    max_string
c      parameter (max_string=120)

! Local Variables

      character*75 buff,fname
      character*20 name
      character*4 str1
      integer i,jchar,ishift,j,flen,nexternal,ichar,nlen,nproc
      integer isym,jhel,initc,iden(maxcross)
      integer nhel(maxlines,3**maxlines),step(maxlines),ihel
      integer ncross,ipart(maxlines,maxcross),ic(maxlines,maxcross)
      integer jline(0:4),imatch(0:maxcross)
      integer icross,iboson
      logical found
      integer nwp,nwm,nz,ngot

! Global Variables

      integer        iline(-maxlines:maxlines),idir(-maxlines:maxlines)
      integer        this_coup(max_coup) ,goal_coup(max_coup)
      common/to_proc/iline,idir,this_coup,goal_coup

      character*15 gname
      integer iname
      common/to_name/iname,gname
      integer         nincoming
      common/to_proc2/nincoming
      character*60 proc
      integer iproc
      common/to_write/iproc,proc

      integer info_p(5,max_particles),iposx(3,max_particles)
      character*(max_string) iwave(max_particles),owave(max_particles)
      character*(8) str(3,max_particles)
      common/to_external/iwave,owave,iposx,info_p,str

      character*(4*max_particles) particle(4)
      integer                               charge_c(max_particles)
      integer iparticle(0:max_particles,0:4),inverse(max_particles)
      common/to_model/iparticle,  particle,  inverse, charge_c

      logical         lwp,lwm,lz,decay,cross
      common/to_decay/lwp,lwm,lz,decay,cross

!-----------
! Begin Code
!-----------
c
c     These lines for artificial decay
c
      if (decay) then
         call getparticle('w+',nwp,ngot)
         if (ngot .ne. 1) print*,'Error finding W+',nwp,ngot
         call getparticle('w-',nwm,ngot)
         if (ngot .ne. 1) print*,'Error finding W+',nwp,ngot
         call getparticle('z',nz,ngot)
         if (ngot .ne. 1) print*,'Error finding W+',nwp,ngot
         lwp=.false.
         lwm=.false.
         lz =.false.
         if (iline(iline(0)) .eq. nwp) lwp=.true.
         if (iline(iline(0)) .eq. nwm) lwm=.true.
         if (iline(iline(0)) .eq. nz ) lz =.true.
         if (lz) then
            call getparticle('e+e-',jline(1),jline(0))
         elseif(lwp) then
            call getparticle('e+ve',jline(1),jline(0))
         elseif(lwm) then
            call getparticle('ve~e-',jline(1),jline(0))
         else
            print*,'Warning last particle not Z or W+ or W-'
            print*,'Not decaying'
            decay=.false.
         endif
      endif
      if (decay) then
         iboson=iline(iline(0))
         iline(0)=iline(0)+1
         iline(iline(0)-1)=jline(1)
         iline(iline(0))=jline(2)
c         print*,'We have decay',decay,lz
      else
c         print*,'No decay'
      endif

      if (cross) then
         call crossing(ncross,ipart,imatch)
      else
         ncross=1
         imatch(0) =1
         imatch(1) =1
         do i=1,iline(0)
            ipart(i,1)=i
         enddo
      endif
c
c set up all the different crossings which are not identical
c
      icross = 0
      do i=1,ncross
         if (imatch(i) .gt. icross) then
            call getdenom(isym,initc,jhel,step,ipart(1,i))
            iden(imatch(i)) = isym*initc*jhel
c            write(*,*) 'iden',i,imatch(i),iden(imatch(i))
            if (imatch(i) .ne. icross+1) then
               print*,'Error in imatch writesub.f',i,imatch(i),icross+1
            endif
            icross=imatch(i)
         endif
      enddo
      if (icross .ne. imatch(0)) then
         print*,'Warning icross .ne. imatch(0)',icross,imatch(0)
      endif
c      write(*,*) 'iden(1)',iden(1)

      ishift = iname
c      nlength = ishift

      name = gname(1:iname)
      call upper_case(name)
      nexternal = iline(0)
      call sethel(nhel,step,nexternal,ihel)

c      buff = 'REAL*8 FUNCTION S'
c      jchar = 18
      buff = 'SUBROUTINE S'
      jchar = 13
      buff(jchar:jchar+ishift) = name(1:iname)
      jchar = jchar+ishift
      ishift= 7
      buff(jchar:jchar+ishift) = '(P1,ANS)'
      jchar =jchar+ishift
      write(92,10) buff(1:jchar)

      call genparton(ncross,ipart,buff(12:jchar),nproc,imatch)

      jchar=jchar-4
      FNAME= buff(13:jchar)
c      FNAME(JCHAR-12:JCHAR-12+13)=',NHEL(1,IHEL))'
      FNAME(JCHAR-12:JCHAR-12+19)=',NHEL(1,IHEL),JC(1))'
      FLEN = jchar+19

! write comments

      write(92,5) ' '
      write(92,5) 'FUNCTION GENERATED BY MADGRAPH'
      write(92,5) 'RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS'
      write(92,5) 'AND HELICITIES'
      write(92,5) 'FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)'
      write(92,5) ' '
      write(92,5) 'FOR PROCESS '//proc(1:iproc)
      write(92,5) ' '
      do i=1,ncross
         buff = 'Crossing ??? is '
         write(buff(10:12),'(i3)') imatch(i)
         ichar = 17
         do j=1,2
            call part_string(inverse(iline(ipart(j,i))),str1,nlen)
            buff(ichar:ichar+nlen-1) = str1(1:nlen)
            ichar=ichar+nlen
            buff(ichar:ichar)=' '
            ichar=ichar+1
         enddo
         buff(ichar:ichar+3) = '-> '
         ichar=ichar+3
         do j=3,iline(0)
            call part_string(iline(ipart(j,i)),str1,nlen)
            buff(ichar:ichar+nlen-1) = str1(1:nlen)
            ichar=ichar+nlen
            buff(ichar:ichar)=' '
            ichar=ichar+1
         enddo
         write(92,5) buff(1:ichar)
      enddo

      write(92,10) 'IMPLICIT NONE'

! write parameters

      write(92,5) ' '
      write(92,5) 'CONSTANTS'
      write(92,5) ' '
      buff = 'INTEGER    NEXTERNAL,   NCOMB,     NCROSS'
      write(92,10) buff(1:50)
      buff = 'PARAMETER (NEXTERNAL=?, NCOMB=???, NCROSS=???)'
      write(buff(22:22),'(i1)') nexternal
      write(buff(31:33),'(i3)') ihel
c      write(buff(43:45),'(i3)') ncross
      write(buff(43:45),'(i3)') icross
      write(92,10) buff(1:46)
      write(92,10) 'INTEGER    THEL'
      write(92,10) 'PARAMETER (THEL=NCOMB*NCROSS)'

      write(92,5) ' '
      write(92,5) 'ARGUMENTS '
      write(92,5) ' '
      write(92,10) 'REAL*8 P1(0:3,NEXTERNAL),ANS(NCROSS)'

      write(92,5) ' '
      write(92,5) 'LOCAL VARIABLES '
      write(92,5) ' '
      write(92,10) 'INTEGER NHEL(NEXTERNAL,NCOMB),NTRY'
      write(92,10) 'REAL*8 T, P(0:3,NEXTERNAL)'
      buff = 'REAL*8 '
      buff(8:7+iname)=name(1:iname)
      write(92,10) buff(1:7+iname)
      write(92,10) 'INTEGER IHEL,IDEN(NCROSS),IC(NEXTERNAL,NCROSS)'
      write(92,10) 'INTEGER IPROC,JC(NEXTERNAL)'
      write(92,10) 'LOGICAL GOODHEL(NCOMB,NCROSS)'
      write(92,10) 'DATA GOODHEL/THEL*.FALSE./'
      write(92,10) 'DATA NTRY/0/'
      BUFF = 'DATA (NHEL(IHEL,???),IHEL=1,?) /'
      write(buff(29:29),'(i1)') nexternal
      do i=1,ihel
         write(buff(17:19),'(i3)') i
         jchar=33
         ishift = 4
         do j=1,nexternal
            write(buff(jchar:jchar+ishift),'(I3,a)') nhel(j,i),','
            jchar=jchar+ishift
         enddo
         jchar=jchar-1
         write(buff(jchar:jchar),'(a1)') '/'
         write(92,10) buff(1:jchar)
      enddo
      BUFF = 'DATA (  IC(IHEL,???),IHEL=1,?) /'
      write(buff(29:29),'(i1)') nexternal
      icross=0
      do i=1,ncross
         if (imatch(i) .gt. icross) then
            write(buff(17:19),'(i3)') imatch(i)
            jchar=33
            ishift = 4
            do j=1,nexternal
c            write(buff(jchar:jchar+ishift),'(I3,a)') ic(j,i),','
            write(buff(jchar:jchar+ishift),'(I3,a)') ipart(j,i),','
            jchar=jchar+ishift
            enddo
            jchar=jchar-1
            write(buff(jchar:jchar),'(a1)') '/'
            write(92,10) buff(1:jchar)
            icross=icross+1
         endif
      enddo
      BUFF = 'DATA (IDEN(IHEL),IHEL=???,???) /'
      do i=1,icross-4,4
c      do i=1,ncross-4,4
         write(buff(23:25),'(i3)') i
         write(buff(27:29),'(i3)') i+3
         jchar=33
         ishift = 5
         do j=0,3
            write(buff(jchar:jchar+ishift),'(I4,a)') iden(j+i),','
            jchar=jchar+ishift
         enddo
         jchar=jchar-1
         write(buff(jchar:jchar),'(a1)') '/'
         write(92,10) buff(1:jchar)
      enddo
      write(buff(23:25),'(i3)') i
      write(buff(27:29),'(i3)') icross
c      write(buff(27:29),'(i3)') ncross
      jchar=33
      ishift = 5
      do j=0,icross-i
c      do j=0,ncross-i
         write(buff(jchar:jchar+ishift),'(I4,a)') iden(j+i),','
         jchar=jchar+ishift
      enddo
      jchar=jchar-1
      write(buff(jchar:jchar),'(a1)') '/'
c      if (i .le. ncross) then
      if (i .le. icross) then
         write(92,10) buff(1:jchar)
      endif
      
      write(92,5) '----------'
      write(92,5) 'BEGIN CODE'
      write(92,5) '----------'
c      buff(1:1)='S'
c      buff(2:iname+1) = name(1:iname)
c      buff(iname+2:iname+7) = ' = 0d0'
c      write(92,10) buff(1:iname+7)
      write(92,10) 'NTRY=NTRY+1'
      write(92,10) 'DO IPROC=1,NCROSS'
      write(92,10) 'CALL SWITCHMOM(P1,P,IC(1,IPROC),JC,NEXTERNAL)'
c
c     Carefull here, if there are no crossings then we don't want
c     to flip the signs of the incoming particles because they already
c     are flipped
c
      if (nincoming .gt. 0) then
         write(92,10) 'DO IHEL=1,NEXTERNAL'
         write(92,10) '   JC(IHEL) = +1'
         write(92,10) 'ENDDO'
      endif
      WRITE(92,10) 'ANS(IPROC) = 0D0'
      write(92,10) 'DO IHEL=1,NCOMB'
      write(92,10) '    IF (GOODHEL(IHEL,IPROC) .OR. NTRY .LT. 2) THEN'
      buff(1:8) = '        '
      buff(8:9)= 'T='
      i=33
      buff(10:10+flen-i) = fname(1:flen-i)  
      buff(10+flen-i+1:10+flen-1) = fname(flen-i+2:flen)
      write(92,10) buff(1:10+flen-1)
c      print*,buff(1:10+flen-1)
      write(92,10) '       ANS(IPROC)=ANS(IPROC)+T'
      buff = '        IF (T .GT. 0D0 .AND. .NOT. '
      buff(36:) ='GOODHEL(IHEL,IPROC)) THEN'
      write(92,10) buff(1:60)
      write(92,10) '            GOODHEL(IHEL,IPROC)=.TRUE.'
      write(92,5) '            WRITE(*,*) IHEL,T'
      write(92,10) '        ENDIF'
      write(92,10) '    ENDIF'
      write(92,10) 'ENDDO'
      buff(1:1) = 'S'
      write(92,10) 'ANS(IPROC)=ANS(IPROC)/DBLE(IDEN(IPROC))'
      write(92,10) 'ENDDO'
      write(92,10) 'END'
      write(92,10) ' '
      write(92,10) ' '
c
c     Now if a decay was made, replace decayed particle in iline
c
      if (decay) then
         iline(0)=iline(0)-1
         iline(iline(0)) = iboson
      endif
 5    format('C ',A)
 10   format(6X,A)
 15   format('C',6X,A)
 20   format(', P',I1)
 30   format(',P',I1,'(0:3)')
      end


      subroutine writesub_f90(ngraphs,nexternal,nqed,nqcd)
!***************************************************************************
!     writes out the subroutine for Fortran 90 
!***************************************************************************
      implicit none

! Constants


! Arguments

      integer ngraphs,nqed,nqcd,nexternal

! Local Variables


!-----------
! Begin Code
!-----------
      end


      subroutine writesum_f90
!***************************************************************************
!     writes out the subroutine - f90 version
!***************************************************************************
      implicit none

      end

      
      subroutine sethel(nhel,step,npart,ihel)
c************************************************************************
c     Sets up all possible helicity combinations in nhel(ipart,ihel)
c     given the number of particles, and the step size to be used
c     for each particle
c     The first state is always -1, the next is 0 or 1 depending onstep
c************************************************************************
      implicit none

!     Constants
      
      include 'params.inc'

!     Arguments
      
      integer nhel(maxlines,3**maxlines),step(maxlines),npart,ihel

!     Local

      integer ipart,iflip
      logical gotone

      ihel=1
      do ipart=1,npart
         nhel(ipart,ihel)=-1
      enddo
      gotone=.true.
      do while (gotone)
c         write(*,'(8I4)'),ihel,(nhel(ipart,ihel),ipart=1,npart)
         ihel=ihel+1
         do ipart=1,npart
            nhel(ipart,ihel)=nhel(ipart,ihel-1)
         enddo
         gotone = .false.
         iflip = npart
         do while(.not. gotone .and. iflip .gt. 0)
            nhel(iflip,ihel) = nhel(iflip,ihel)+step(iflip)
            if (nhel(iflip,ihel) .gt. 1) then
               nhel(iflip,ihel) = -1
               iflip =iflip-1
            else
               gotone=.true.
            endif
         enddo
      enddo
      ihel=ihel-1
      end


!-------------------------------------
      subroutine lower_case(string)
      implicit none

! Constants

      integer    char_a,              char_z
c      parameter (char_a = ichar('A'), char_z = ichar('Z'))
      integer    lcshift
c      parameter (lcshift = ichar('a') - ichar('A'))


! Argument

      character*(*) string

! Local Variable

      integer i

!-----------
! Begin Code
!-----------
      char_a = ichar('A')
      char_z = ichar('Z')
      lcshift = ichar('a')-ichar('A')
      do i=1,len(string)
         if (ichar(string(i:i)) .ge. char_a .and.
     &       ichar(string(i:i)) .le. char_z) then
            string(i:i)=char(ichar(string(i:i))+lcshift)
         end if
      end do
      end

!-------------------------------------
      subroutine upper_case(string)
      implicit none

! Constants

      integer    char_a,              char_z
c      parameter (char_a = ichar('a'), char_z = ichar('z'))
      integer    ucshift
c      parameter (ucshift = ichar('A') - ichar('a'))

! Argument

      character*(*) string

! Local Variable

      integer i

!-----------
! Begin Code
!-----------
      char_A = ichar('a')
      char_Z = ichar('z')
      ucshift = ichar('A')-ichar('a')
c      write(*,*) string
      do i=1,len(string)
         if (ichar(string(i:i)) .ge. char_a .and.
     &       ichar(string(i:i)) .le. char_z) then
            string(i:i)=char(ichar(string(i:i))+ucshift)
         end if
      end do
c      write(*,*) string
      end


      subroutine writebuff2(buff,lun)

      implicit none

! Arguments

      character*(*) buff
      integer lun

! Local Variables

      integer length,i

!-----------
! Begin Code
!-----------
      length = len(buff)
      if (length .le. 60) then
         write (lun,100) buff
      else
         i = 60
         do while (buff(i:i) .ne. '+' .and. buff(i:i).ne.'-')
            i = i - 1
         end do
         if (length-i .gt. 60) then
            print*,'Sorry buff too long in writebuff2',length,i
            print*,buff(:i)
            print*,buff(i:i+60)
            print*,buff(i+60:)
         endif
         write (lun,100) buff(:i)
         write (lun,200) buff(i+1:)
      end if
 100  format ('      ',a)
 200  format ('     &     ',a)
      end

      
