!-----------------------
! madgraph - a Feynman Diagram package by Tim Stelzer and Bill Long 
! (c) 1993
!
! Filename: writedsig.f
!-----------------------
      subroutine writedsig(NLINES,lun)
c***********************************************************************
c     Routine to write subroutine dsig.f
c***********************************************************************
      implicit none
c
c     Constants
c
      integer    ln
      parameter (ln=29)
c
c     Arguments
c
      integer nlines,lun
c
c     Local
c
      character*70 buff
c
c     Global
c
      integer        ndsig,nproc,nperm
      common/to_dsig/ndsig,nproc,nperm
      integer        tcount
      common/to_wgt/ tcount

      logical         lwp,lwm,lz,decay,cross
      common/to_decay/lwp,lwm,lz,decay,cross

c-----
c Begin Code
c-----
      open(unit=ln,file='auto_dsig.f',status='unknown')
      write(ln,10) 'DOUBLE PRECISION FUNCTION DSIG(WGT,X)'
! write comments

      write(ln,5) ' '
      write(ln,5) 'FUNCTION GENERATED BY MADGRAPHII'
      write(ln,5) 'RETURNS DIFFERENTIAL CROSS SECTION'
      write(ln,5) 'FOR THE POINT USING RANDOM NUMBERS x(i)'
      write(ln,5) ' '

      write(ln,10) 'IMPLICIT NONE'

! write parameters

      write(ln,5)  ' '
      write(ln,5)  'CONSTANTS'
      write(ln,5)  ' '
      write(ln,10)            'INTEGER    NEXTERNAL'
      if (decay) then
         write(ln,'(6x,a,i1,a)') 'PARAMETER (NEXTERNAL=',nlines+1,')'
      else
         write(ln,'(6x,a,i1,a)') 'PARAMETER (NEXTERNAL=',nlines,')'
      endif
      write(ln,10)            'INTEGER    NDSIG     ,NPROC     ,NPERM'
      write(ln,'(6x,a,i3,a,i3,a,i3,a)') 'PARAMETER (NDSIG=',27,
     $     ' ,NPROC=',nproc,' ,NPERM=',nperm,')'
      write(ln,10) 'REAL       CONV'
      write(ln,10) 'PARAMETER (CONV=389379.66*1000)  !CONV TO PICOBARNS'
      write(ln,10) 'INTEGER    C0B0   , C0B1   , C0B2    '
      write(ln,10) 'PARAMETER (C0B0= 1, C0B1= 2, C0B2= 3)'
      write(ln,10) 'INTEGER    C0B3   , C0B4   , C1B0    '
      write(ln,10) 'PARAMETER (C0B3= 4, C0B4= 5, C1B0= 6)'
      write(ln,10) 'INTEGER    C1B1   , C1B2   , C1B3    '
      write(ln,10) 'PARAMETER (C1B1= 7, C1B2= 8, C1B3= 9)'
      write(ln,10) 'INTEGER    C2B0   , C2B1   , C2B2    '
      write(ln,10) 'PARAMETER (C2B0=10, C2B1=11, C2B2=12)'
      write(ln,10) 'INTEGER    C3B0   , C3B1   , C4B0    '
      write(ln,10) 'PARAMETER (C3B0=13, C3B1=14, C4B0=15)'
      write(ln,10) 'INTEGER    NG0   , NG1   , NG2   , NG3   , NG4'
      write(ln,10) 'PARAMETER (NG0=16, NG1=17, NG2=18, NG3=19, NG4=20)'
      write(ln,10) 'INTEGER    NG5   , NG6   , NG7'
      write(ln,10) 'PARAMETER (NG5=21, NG6=22, NG7=23)'
      write(ln,10) 'INTEGER    GG   , GQ   , QG   , QQ '
      write(ln,10) 'PARAMETER (GG=24, GQ=25, QG=26, QQ=27)'
      write(ln,10) 'INTEGER    MAXPROC'
      write(ln,'(6x,a,i4,a)') 'PARAMETER (MAXPROC=',tcount,')'
      write(ln,10) 'REAL*8     PI'
      write(ln,10) 'PARAMETER (PI=3.1415926)'
! write argument declarations

      write(ln,5) ' '
      write(ln,5) 'ARGUMENTS '
      write(ln,5) ' '

      write(ln,10) 'DOUBLE PRECISION X(3*(NEXTERNAL-2)-4+2), WGT'

! write local declarations

      write(ln,5) ' '
      write(ln,5) 'LOCAL VARIABLES '
      write(ln,5) ' '
      write(ln,10) 'INTEGER I, IPROC,ITYPE'
      write(ln,10) 'DOUBLE PRECISION P1(0:3,NEXTERNAL)'
c      write(ln,10) 'DOUBLE PRECISION Pp1(0:3),P2(0:3),P3(0:3),P4(0:3)'
c      write(ln,10) 'DOUBLE PRECISION P5(0:3),P6(0:3),P7(0:3),P8(0:3)'
      write(ln,10) 'DOUBLE PRECISION DSIG1(NDSIG)'
      write(ln,10) 'DOUBLE PRECISION ANS(NPERM,NPROC)'
      write(ln,10) 'DOUBLE PRECISION ALPHA_S,XNFN,Q2REN'
      write(ln,10) 'DOUBLE PRECISION u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1'
      write(ln,10) 'DOUBLE PRECISION u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2'
      write(ln,10) 'DOUBLE PRECISION g1,g2'
      write(ln,10) 'DOUBLE PRECISION XPQ1(-6:6),XPQ2(-6:6),Q2SCAL,SCALE'
      write(ln,10) 'DOUBLE PRECISION FRACT(MAXPROC),TOTFRAC,SUM'
      write(ln,5) ' '
      write(ln,5) 'EXTERNAL FUNCTIONS'
      write(ln,5) ' '
      write(ln,10) 'LOGICAL PASSCUTS'
      write(ln,10) 'DOUBLE PRECISION ALPHAS2'
      write(ln,5) ' '
      write(ln,5) 'GLOBAL VARIABLES'
      write(ln,5) ' '
      write(ln,10) 'DOUBLE PRECISION    S,X1,X2,PSWGT,JAC'
      write(ln,10) 'COMMON /PHASESPACE/ S,X1,X2,PSWGT,JAC'
      write(ln,10) 'DOUBLE PRECISION  WMASS,WWIDTH,ZMASS,ZWIDTH'
      write(ln,10) 'COMMON /VMASS1/   WMASS,WWIDTH,ZMASS,ZWIDTH'
      write(ln,10) 'DOUBLE PRECISION GG1(2), G'
      write(ln,10) 'COMMON /COUPQCD/ GG1,    G'
c      write(ln,10) 'DOUBLE PRECISION TOTDSIG1(NDSIG),TOTDSIG2(NDSIG)'
c      write(ln,10) 'COMMON /TOANS/   TOTDSIG1       ,TOTDSIG2'
      write(ln,10) 'DOUBLE PRECISION QCDL4,QCDL5'
      write(ln,10) 'COMMON/W50512/   QCDL4,QCDL5'
c      write(ln,10) 'LOGICAL         LQ2, LQ4, LQ6'
c      write(ln,10) 'COMMON /TOPROC/ LQ2, LQ4, LQ6'
c      write(ln,10) 'INTEGER          IALPHA'
c      write(ln,10) 'COMMON /TOALPHA/ IALPHA'
      write(ln,10) 'REAL*4             TOTDSIG(0:NDSIG)'
      write(ln,10) 'COMMON /TO_RESULT/ TOTDSIG'
c      write(ln,10) 'DOUBLE PRECISION WGT1       ! DSAMPLE INFO'
c      write(ln,10) 'COMMON/TO_MYWGT/ WGT1'
c      write(ln,10) 'INTEGER ITREE'
c      write(ln,10) 'COMMON/TO_TREE/ ITREE'
c      write(ln,10) 'DOUBLE PRECISION          VAL(20)'
c      write(ln,10) 'CHARACTER*20    PARM(20)'
c      write(ln,10) 'COMMON /TOPDF/  PARM,     VAL'
      write(ln,5) ' '
      write(ln,5) 'DATA'
      write(ln,5) ' '
c      write(ln,10) 'DATA TOTDSIG1/NDSIG*0d0/'
c      write(ln,10) 'DATA TOTDSIG2/NDSIG*0d0/'
c      write(ln,10) 'DATA  LQ2, LQ4, LQ6 /.TRUE.,.TRUE.,.TRUE./'
      write(ln,10) 'DATA u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1,g1/11*0d0/'
      write(ln,10) 'DATA u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2,g2/11*0d0/'
      write(ln,10) 'DATA XNFN,Q2REN,Q2SCAL/5,6561d0,6561d0/'
      write(ln,5) '----------'
      write(ln,5) 'BEGIN CODE'
      write(ln,5) '----------'
c      write(ln,10) 'ITREE= IPOLE'
      write(ln,10) 'DSIG = 0D0'
      write(ln,10) 'DO I = 1, NDSIG'
      write(ln,15) 'DSIG1(I) = 0D0'
c      write(ln,15) 'DSIG2(I) = 0D0'
      write(ln,10) 'ENDDO'
c      write(ln,10) 'WGT1=WGT'
c      write(ln,10) 'CALL GENCMS(S,X1,X2,X(1),SMIN,SJACOBI)'
      write(ln,10) 'JAC = 1d0'
c      write(ln,10) 'CALL GENMOM(X,p1,NEXTERNAL)'
      write(ln,10) 'CALL CONGEN(X,NEXTERNAL,P1)'
c      write(ln,10) 'DO I=0,3'
c      write(ln,15) 'P1(I,1)=Pp1(I)'
c      write(ln,15) 'P1(I,2)=P2(I)'
c      write(ln,15) 'P1(I,3)=P3(I)'
c      write(ln,15) 'P1(I,4)=P4(I)'
c      write(ln,15) 'P1(I,5)=P5(I)'
c      write(ln,15) 'P1(I,6)=P6(I)'
c      write(ln,15) 'P1(I,7)=P7(I)'
c      write(ln,15) 'P1(I,8)=P8(I)'
c      write(ln,10) 'ENDDO'
      write(ln,10) 'IF (PASSCUTS(p1)) THEN'
c      write(ln,15) 'CALL PDFSET(PARM,VAL)'
c      write(ln,15) 'IF (IALPHA .EQ. 1) THEN'
      WRITE(LN,20) 'q2scal = (x1*x2*s)'
c      WRITE(LN,15) 'ELSE'
c      WRITE(LN,20) 'Q2SCAL = ZMASS*ZMASS'
c      WRITE(LN,15) 'ENDIF'
      WRITE(LN,15) 'SCALE=DSQRT(Q2SCAL)'
      write(ln,15) 'CALL PFTOPDG(X1,SCALE,XPQ1)'
      write(ln,15) 'CALL PFTOPDG(X2,SCALE,XPQ2)'
      write(ln,15) 'DO I=-6,6'
      write(ln,20) 'XPQ1(i)=XPQ1(i)/X1'
      write(ln,20) 'XPQ2(i)=XPQ2(i)/X2'
      write(ln,15) 'ENDDO'
      write(ln,15) 'ITYPE=1         !1=PROTON -1=ANTIPROTON'           
      write(ln,15) 'g1 = xpq1(0)'
      write(ln,15) 'd1 = xpq1(1*ITYPE)'
      write(ln,15) 'u1 = xpq1(2*ITYPE)'
      write(ln,15) 's1 = xpq1(3*ITYPE)'
      write(ln,15) 'c1 = xpq1(4*ITYPE)'
      write(ln,15) 'b1 = xpq1(5*ITYPE)'
      write(ln,15) 'db1= xpq1(-1*ITYPE)'
      write(ln,15) 'ub1= xpq1(-2*ITYPE)'
      write(ln,15) 'sb1= xpq1(-3*ITYPE)'
      write(ln,15) 'cb1= xpq1(-4*ITYPE)'
      write(ln,15) 'bb1= xpq1(-5*ITYPE)'
      write(ln,15) 'ITYPE=1         !1=PROTON -1=ANTIPROTON'           
      write(ln,15) 'g2 = xpq2(0)'
      write(ln,15) 'db2= xpq2(-1*ITYPE)'
      write(ln,15) 'ub2= xpq2(-2*ITYPE)'
      write(ln,15) 'sb2= xpq2(-3*ITYPE)'
      write(ln,15) 'cb2= xpq2(-4*ITYPE)'
      write(ln,15) 'bb2= xpq2(-5*ITYPE)'
      write(ln,15) 'd2 = xpq2(1*ITYPE)'
      write(ln,15) 'u2 = xpq2(2*ITYPE)'
      write(ln,15) 's2 = xpq2(3*ITYPE)'
      write(ln,15) 'c2 = xpq2(4*ITYPE)'
      write(ln,15) 'b2 = xpq2(5*ITYPE)'
c      WRITE(LN,15) 'IF (IALPHA .LE. 2) THEN'
c      write(ln,20)
c     &  'ALPHA_S = 12.D0*PI/( (33.D0-2.D0*XNFN)*DLOG(Q2SCAL/QCDL5**2))'
c      WRITE(LN,15) 'ELSE'
c      WRITE(LN,20)
c     &  'ALPHA_S = 12.D0*PI/( (33.D0-2.D0*XNFN)*DLOG(Q2SCAL/QCDL4**2))'
c      WRITE(LN,15) 'ENDIF'
C      write(ln,15) 'ALPHA_S = .1365D0'
      write(ln,15) 'G = SQRT(4.0*PI*ALPHAS2(SCALE))'
      write(ln,15) 'GG1(1) = -G'
      write(ln,15) 'GG1(2) = -G'
      do while (.true.)
         read(lun,'(a)',end=999) buff
         write(ln,15) buff
      enddo
 999  continue
      write(ln,5) ' '
      write(ln,5) '     Careful, if more than one dsig you need to'
      write(ln,5) '     check totdsig(i) so it adds rather than resets.'
      write(ln,5) ' '
      write(ln,15) 'DO I=1,NDSIG'
      write(ln,20) 'DSIG1(I) = DSIG1(I)*JAC*PSWGT*CONV'
      write(ln,20) 'DSIG=DSIG+DSIG1(I)'
      write(ln,20) 'TOTDSIG(I)=TOTDSIG(I)+WGT*DSIG1(I)'
      write(ln,15) 'ENDDO'
      write(ln,15) 'DSIG=DSIG/3D0'
      write(ln,15) 'CALL GRAPH_POINT2(DBLE(DSIG*WGT),P1)'
c      write(ln,15) 'WGT=WGT1'
      write(ln,15) 'RETURN'
      write(ln,5) ' '
      write(ln,5) '     Below is for returning parton flavors.'
      write(ln,5) ' '
      write(ln,15) 'TOTFRAC = 0D0'
      write(ln,15) 'DO I=1,MAXPROC'
      write(ln,20) 'TOTFRAC = TOTFRAC+FRACT(I)'
      write(ln,15) 'ENDDO'
      write(ln,15) 'SUM = FRACT(1)'
      write(ln,15) 'IPROC = 1'
      write(ln,15) 'DO WHILE (SUM/TOTFRAC .LT. .5D0)'
      write(ln,20) 'IPROC=IPROC+1'
      write(ln,20) 'SUM=SUM+FRACT(IPROC)'
      write(ln,15) 'ENDDO'
      write(ln,10) 'ENDIF'
      write(ln,10) 'END'

      close(ln)
 5    format('C ',A)
 10   format(6X,A)
 15   format(9X,A)
 20   format(12X,A)
 21   format(5x,'&',9x,A)
      end

      subroutine genparton(ncross,ipart,fname,nproc,imatch)
c*************************************************************************
c     Writes out calls for the parton distributions which must be folded
c     with the different cross sections
c*************************************************************************
      implicit none
      
! Constants

      include 'params.inc'
c      integer    maxlines  , maxcross    , max_coup
c      parameter (maxlines=8, maxcross=200, max_coup=5)
c      integer    max_particles       
c      parameter (max_particles=2**7-1)

! Arguments

      integer ncross,ipart(maxlines,maxcross),nproc,imatch(0:maxcross)
      character*(*) fname

! Local
      integer i,j,nlen(7),lun
      integer ib,ic,nb,nch,nl,ig,ng,nq,nfound
      integer ichar,jchar
      character*5 ch(7)
      character*6 buff
      character*20 cname
      character*2 cinit

! Global Variables

      integer        iline(-maxlines:maxlines),idir(-maxlines:maxlines)
      integer        this_coup(max_coup) ,goal_coup(max_coup)
      common/to_proc/iline,idir,this_coup,goal_coup

      character*(4*max_particles) particle(4)
      integer                               charge_c(max_particles)
      integer iparticle(0:max_particles,0:4),inverse(max_particles)
      common/to_model/iparticle,  particle,  inverse, charge_c
      integer        nsubproc,nproc1,nperm
      common/to_dsig/nsubproc,nproc1,nperm
      logical         lwp,lwm,lz,decay,cross
      common/to_decay/lwp,lwm,lz,decay,cross
      integer        tcount
      common/to_wgt/ tcount

      data nperm,nproc1/-1,-1/
      data tcount/0/
!-----
! Begin Code
!-----
      lun = 22
      nsubproc = 22
      nproc1=max(nproc,nproc1)
      call getparticle('b',ib,nfound)
      if (nfound .ne. 1) print*,'Warning couldnt find b',ib,nfound
      call getparticle('c',ic,nfound)
      if (nfound .ne. 1) print*,'Warning couldnt find c',ic,nfound
      call getparticle('g',ig,nfound)
      if (nfound .ne. 1) print*,'Warning couldnt find g',ig,nfound

CC      write(lun,'(a,i3)') 'IPROC = ',abs(nproc)
CC      if (nproc .gt. 0) then
CC         write(lun,10) 'CALL ',fname(1:len(fname)-1),'(1,IPROC))'
CC      endif
      nperm=max(nperm,ncross)
      do i=1,ncross
         tcount=tcount+1
CC         write(71,'($2i6,2x)') tcount,nproc
         do j=1,2
            call part_string(inverse(iline(ipart(j,i))),ch(j),nlen(j))
CC            write(71,'($a4)') ch(j)
            ch(j)(2:2)='b'
         enddo
CC         write(71,'($a4)') ' -> '
         nl=0
         nch=0
         nb=0
         cname=' !'
         ichar=3
         do j=3,iline(0)
            call part_string(iline(ipart(j,i)),cname(ichar:ichar+2),
     &           jchar)
CC            write(71,'($a4)') cname(ichar:ichar+2)
            ichar=ichar+jchar
            if (iline(ipart(j,i)) .eq. ib .or.
     &           inverse(iline(ipart(j,i))) .eq. ib) then
               nb=nb+1
            elseif (iline(ipart(j,i)) .eq. ic .or.
     &           inverse(iline(ipart(j,i))) .eq. ic) then
               nch=nch+1
            else
               nl=nl+1
            endif
         enddo
CC         write(71,*) ' '
         do j=1,2
            if (iline(ipart(j,i)) .eq. ig .or.
     &           inverse(iline(ipart(j,i))) .eq. ig) then
               CINIT(j:j)='G'
            else
               CINIT(j:J)='Q'
            endif
         enddo
         ng=0
         do j=1,iline(0)
            if (iline(ipart(j,i)) .eq. ig .or.
     &           inverse(iline(ipart(j,i))) .eq. ig) then
               ng=ng+1
            endif
         enddo
         if (ng .gt. 7 .or. ng .lt. 0) then
            print*,'Warning bad number of gluons in gendsig.f',ng
         endif
         ch(1)(nlen(1)+1:nlen(1)+1)='1'
         ch(2)(nlen(2)+1:nlen(2)+1)='2'

c
c     Below is for keeping track of heavy quark flavors
c
         write(buff,'(a1,i1,a1,i1)') 'C',nch,'B',nb
CC         write(lun,23) '   DSIG1(',buff(1:6),') = DSIG1(',buff(1:6),
CC     $       ') + ANS(',imatch(i),',IPROC) * ',ch(1)(1:nlen(1)+1),' * ',
CC     $       ch(2)(1:nlen(2)+1),cname(1:ichar)

c
c     This if for determing the number of quarks vs gluons in process.
c
         write(buff,'(a2,i1,a1,i1,2x)') 'NG',ng
CC         write(lun,22) '   DSIG1(',buff(1:6),') = DSIG1(',buff(1:6),
CC     $       ') + ANS(',imatch(i),',IPROC) * ',ch(1)(1:nlen(1)+1),' * ',
CC     $        ch(2)(1:nlen(2)+1)

c
c     This if for determing the initial state configuration ie gg,qg,gq,gg
c
         write(buff,'(a2,4x)') cinit
CC         write(lun,22) '   DSIG1(',buff(1:6),') = DSIG1(',buff(1:6),
CC     $       ') + ANS(',imatch(i),',IPROC) * ',ch(1)(1:nlen(1)+1),' * ',
CC     $        ch(2)(1:nlen(2)+1)

c
c     This is for determining the exact parton configuration
c
CC         write(lun,24) '   FRACT(',tcount,
CC     &        ') = ans(',imatch(i),',IPROC) * ',ch(1)(1:nlen(1)+1),' * '
CC     $        ,ch(2)(1:nlen(2)+1)

 22      format(5a,i2,a,a3,a,a3)
 23      format(5a,i2,a,a3,a,a3,a)
 24      format(a,i6,a,i2,a,a,a3,a)
c         write(lun,20) 'DSIG = DSIG + ',ch
c         write(lun,20) 'DSIG = DSIG + ',ch(1)(1:nlen(1)+1),' * ',
c     &        ch(2)(1:nlen(2)+1),' * ','ANS(',i,' ,IPROC)',
c     &        ' * L',nl,' * C',nch,' * B',nb
      enddo
c      write(lun,'(a)') 'ENDIF'
CC      write(lun,*)
CC      write(71,*)
 10   format( 3a,a)
 25   format( a,a3,a3,a3,a3,a4,i3,a,i3,a1,a,i1,a,i1,a,i1)
 20   format( a,3a3,2a,i3,a,a,i1,a,i1,a,i1)
      end









